﻿
using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

class Service
{
    static void Main(string[] args)
    {
        string acsHostName = "accesscontrol.windows.net";

        string trustedAudience = "http://localhost/SampleService";
        string requiredClaimType = "action";
        string requiredClaimValue = "sayHello";

        Console.WriteLine("Enter your service namespace, then press <ENTER>");
        string serviceNamespace = Console.ReadLine();

        Console.WriteLine("\nEnter your issuer key, then press <ENTER>");
        string trustedTokenPolicyKey = Console.ReadLine();

        WebHttpBinding binding = new WebHttpBinding(WebHttpSecurityMode.None);

        Uri address = new Uri("http://localhost/SampleService");

        WebServiceHost host = new WebServiceHost(typeof(SampleService));
        host.AddServiceEndpoint(typeof(ISampleService), binding, address);

        host.Authorization.ServiceAuthorizationManager = new ACSAuthorizationManager(
            acsHostName,
            serviceNamespace,
            trustedAudience,
            Convert.FromBase64String(trustedTokenPolicyKey),
            requiredClaimType,
            requiredClaimValue);

        host.Open();

        Console.WriteLine("The Sample Service is listening");
        Console.WriteLine("Press <ENTER> to exit");
        Console.ReadLine();
    }
}

