@echo off
setlocal

echo.
echo Setting up the ACS WCF Auth Manager Sample
echo.

echo Configuring ACS
echo.

SET toolpath=%~dp0..\..\..\..\Tools\

SET /P acsolution=Please enter your Service Namespace: 
SET /P acmgmtkey=Please enter your Management key: 
echo.

"%toolpath%acm.exe" create tokenpolicy -name:SampleService -autogeneratekey -service:%acsolution% -mgmtkey:%acmgmtkey% -simpleout > tokenpolicy.tmp
SET /p tokenpolicyid=<tokenpolicy.tmp

SET policyCreated=%tokenpolicyid:~0,3%
if "%policyCreated%"=="tp_" ( 
	    echo Token policy created 
	) else ( 
	    goto :error
	)

echo.
"%toolpath%acm.exe" create scope -name:SampleService -appliesto:http://localhost/SampleService -tokenpolicyid:%tokenpolicyid% -service:%acsolution% -mgmtkey:%acmgmtkey% -simpleout > scope.tmp
SET /p scopeid=<scope.tmp

SET scopeCreated=%scopeid:~0,4%
if "%scopeCreated%"=="scp_" ( 
	    echo Scope created 
	) else ( 
	    goto :error
	)

echo.
"%toolpath%acm.exe" create issuer -name:SampleService -issuername:SampleService -autogeneratekey -service:%acsolution% -mgmtkey:%acmgmtkey% -simpleout > issuer.tmp
SET /p issuerid=<issuer.tmp

SET issuerCreated=%issuerid:~0,4%
if "%issuerCreated%"=="iss_" ( 
	    echo Issuer created 
	) else ( 
	    goto :error
	)

echo.
"%toolpath%acm.exe" create rule -name:SampleService -scopeid:%scopeid% -inclaimissuerid:%issuerid% -inclaimtype:Issuer -inclaimvalue:SampleService -outclaimtype:action -outclaimvalue:sayHello -service:%acsolution% -mgmtkey:%acmgmtkey% -simpleout > rule.tmp
SET /p ruleid=<rule.tmp
echo Rule created
echo.

"%toolpath%acm.exe" get issuer -id:%issuerid% -service:%acsolution% -mgmtkey:%acmgmtkey% > key.tmp
findstr /C:=<key.tmp > keyvalue.tmp
SET /P keyvalue=<keyvalue.tmp
echo Client Issuer %keyvalue%

"%toolpath%acm.exe" get tokenpolicy -id:%tokenpolicyid% -service:%acsolution% -mgmtkey:%acmgmtkey% > tp.tmp
findstr /C:=<tp.tmp > tpkey.tmp
SET /P tpkey=<tpkey.tmp
echo Service Token Policy %tpkey%

echo.
echo Done.

erase *.tmp

goto endscript

:error

echo.
echo Sample setup failed
goto :endscript

:endscript