﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Client.ServiceReference;
using System.ServiceModel.Channels;

namespace Client
{
    class Program
    {
        static void Main(string[] args)
        {
            string purchaseOrderId = SubmitPO();

            Console.WriteLine("The PO Number {0} was submitted", purchaseOrderId);

            string message = ConfirmPO(purchaseOrderId);

            Console.WriteLine(message);

        }

        private static string SubmitPO()
        {
            PurchaseOrder po = new PurchaseOrder
            {
                Customer = "Foo Bar",
                Product = "Product",
                Quantity = 10,
                UnitPrice = 5
            };

            ServiceClient client = new ServiceClient();

            SubmitPOResponse response = client.SubmitPO(po);

            return response.PurchaseOrderId;
        }

        private static string ConfirmPO(string purchaseOrderId)
        {
            ServiceClient client = new ServiceClient();

            return client.ConfirmPO(new ConfirmPO { PurchaseOrderId = purchaseOrderId });
        }
    }
}