﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Client.ServiceReference;
using System.ServiceModel.Channels;

namespace Client
{
    class Program
    {
        static void Main(string[] args)
        {

            string instanceId;

            string poNumber = SubmitPO(out instanceId);

            Console.WriteLine("The PO Number is {0}", poNumber);

            string message = ConfirmPO(instanceId);

            Console.WriteLine(message);

        }

        private static string SubmitPO(out string instanceId)
        {
            PurchaseOrder po = new PurchaseOrder
            {
                Customer = "Foo Bar",
                Product = "Product",
                Quantity = 10,
                UnitPrice = 5
            };

            ServiceClient client = new ServiceClient();

            string poNumber = client.SubmitPO(po);

            IContextManager contextManager = client.InnerChannel.GetProperty<IContextManager>();
            IDictionary<string, string> context = contextManager.GetContext();

            instanceId = context["instanceId"];

            return poNumber;
        }

        private static string ConfirmPO(string instanceId)
        {
            ServiceClient client = new ServiceClient();

            Dictionary<string, string> context = new Dictionary<string, string>();

            context.Add("instanceId", instanceId);

            IContextManager contextManager = client.InnerChannel.GetProperty<IContextManager>();

            contextManager.SetContext(context);

            return client.ConfirmPO();
        }
    }
}