﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.IdentityModel.Tokens;
using System.IdentityModel.Tokens;
using Microsoft.IdentityModel.Claims;

namespace WCFBook.Samples
{
    public class CustomUsernameTokenHandler : UserNameSecurityTokenHandler
    {
        public override bool CanValidateToken
        {
            get
            {
                return true;
            }
        }
        public override Microsoft.IdentityModel.Claims.ClaimsIdentityCollection ValidateToken(System.IdentityModel.Tokens.SecurityToken token)
        {
            UserNameSecurityToken userNameToken = token as UserNameSecurityToken;
            if (userNameToken.UserName != "joe" ||
                userNameToken.Password != "bar")
            {
                throw new SecurityTokenValidationException("The user can not be authenticated");
            }

            return new ClaimsIdentityCollection(new IClaimsIdentity[] {
                new ClaimsIdentity(
                    new Claim[] {
                        new Claim(System.IdentityModel.Claims.ClaimTypes.Name, userNameToken.UserName) }, 
                    "CustomUsernameTokenHandler")});

        }

        
    }
}
