﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Runtime.Serialization;
using System.IdentityModel.Selectors;
using System.IdentityModel.Tokens;
using Microsoft.IdentityModel.Tokens;
using Microsoft.IdentityModel.Configuration;

namespace WCFBook.Samples
{
    class Program
    {
        static void Main(string[] args)
        {
            ServiceHost host = new ServiceHost(typeof(EchoClaims), 
                new Uri("http://localhost:8000"));
            try
            {
                ServiceConfiguration configuration = new ServiceConfiguration();
                configuration.CertificateValidationMode = System.ServiceModel.Security.X509CertificateValidationMode.None;
                configuration.RevocationMode = System.Security.Cryptography.X509Certificates.X509RevocationMode.NoCheck;

                FederatedServiceCredentials.ConfigureServiceHost(host, configuration);

                host.Open();

                Console.WriteLine("Service running....");
                Console.WriteLine("Press a key to quit");
                Console.ReadKey();
            }
            finally
            {
                host.Close();
            }
        }
    }
}
