﻿using System;
using Wrox.CarRentalService.Contracts;
using System.ServiceModel;
namespace Wrox.CarRentalService.Implementations.Europe
{
    [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall)]
    public class CarRentalService : ICarRentalService, IDisposable
    {
        public CarRentalService()
        {
            Console.WriteLine("CarRentalService Constructor");
        }
        public double CalculatePriceV1(DateTime pickupDate,
        DateTime returnDate,
        string pickupLocation, string returnLocation)
        {
            double price = 0;
            if (returnLocation.Equals("Wien"))
                price = 120;
            else
                price = 100;
            return price;
        }
        public Guid ConfirmV1(DateTime pickupDate, DateTime returnDate,
        string pickupLocation, string returnLocation, double price)
        {
            Guid confirmationNumber = Guid.NewGuid();
            //save confirmation to database
            return confirmationNumber;
        }
        public PriceCalculationResponse CalculatePriceV2(
        DateTime pickupDate, DateTime returnDate,
            string pickupLocation, string returnLocation)
        {
            PriceCalculationResponse resp = null;
            resp = new PriceCalculationResponse();
            Guid requestId = Guid.NewGuid();
            resp.RequestID = requestId;
            if (returnLocation.Equals("Wien"))
                resp.Price = 120;
            else
                resp.Price = 100;
            //Save request to database
            return resp;
        }
        public Guid ConfirmV2(Guid requestID)
        {
            //load request from Database
            Guid confirmationNumber = Guid.NewGuid();
            //save confirmation to database
            return confirmationNumber;
        }
        public void ReportCrash(DateTime date,
        String location, Guid confirmationID)
        {
            //load values from database
            Console.WriteLine(@"Crash reported Date {0} Location {1} Confirmation ID {2}",
            date, location, confirmationID);
        }
        public void Dispose()
        {
            Console.WriteLine("CarRentalService disposed...");
        }
    }
}