echo off


REM **
echo ************
echo NOTE: This batch file must be run from a Visual Studio Command Prompt
echo ************

REM ** This batch file
REM ** 1) Sets the directories and file access privilege depending on the OS.
REM **    This is necessary so that the WSE trace files can be successfully written
REM ** 2) Generates and installs sample certificates into the certificate stores
REM ** 	  for use with the Quickstart samples. 
REM ** 

echo See the WSSP Quickstart Readme.txt in this directory for more details.
echo ******* Important ******* 


REM ** Set up the Certificates
set SERVER_NAME=WCFServer
set CLIENT_NAME=WCFClient
set STS_NAME=WCFSTS
set ROOT_NAME=WCFRoot

echo %ROOT_NAME%

echo ************
echo Removing any WSE certificates that are already installed
echo ************

certmgr -del -r LocalMachine -s Root -c -n %ROOT_NAME%

REM Server Certs
certmgr -del -r LocalMachine -s My -c -n %SERVER_NAME%

REM Client Cert
certmgr -del -r LocalMachine -s My -c -n %CLIENT_NAME%

REM STS Certs
certmgr -del -r LocalMachine -s My -c -n %STS_NAME%

echo ************
echo Making Root cert
echo ************
makecert -pe -n CN=%ROOT_NAME% -ss Root -sr LocalMachine -a sha1 -sky signature

echo ************
echo Server cert setup starting
echo %SERVER_NAME%
echo ************
echo Making server cert
echo ************
makecert.exe -sr LocalMachine -ss My -a sha1 -n CN=%SERVER_NAME% -sky exchange -pe -is Root -ir LocalMachine -in %ROOT_NAME%

echo ************
echo Client cert setup starting
echo %CLIENT_NAME%
echo ************
echo Making client cert
echo ************
makecert.exe -sr LocalMachine -ss My -a sha1 -n CN=%CLIENT_NAME% -sky exchange -pe -is Root -ir LocalMachine -in %ROOT_NAME%
echo ************

echo ************
echo STS cert setup starting
echo %STS_NAME%
echo ************
echo Making STS cert
echo ************
makecert.exe -sr LocalMachine -ss My -a sha1 -n CN=%STS_NAME% -sky exchange -pe -is Root -ir LocalMachine -in %ROOT_NAME%
echo ************

