﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace Client
{
    class Program
    {
        static void Main(string[] args)
        {
            EchoClaimsReference.EchoClaimsClient client = new Client.EchoClaimsReference.EchoClaimsClient();

            try
            {
                client.ClientCredentials.UserName.UserName = "joe";
                client.ClientCredentials.UserName.Password = "bar";
                
                string[] claims = client.Echo();

                foreach (string claim in claims)
                {
                    Console.WriteLine(claim);
                }

                client = new Client.EchoClaimsReference.EchoClaimsClient(); 

                //Trying again with a wrong password. An exception must be thrown
                client.ClientCredentials.UserName.UserName = "joe";
                client.ClientCredentials.UserName.Password = "Wrong Password";

                client.Echo();
            }
            catch (TimeoutException exception)
            {
                Console.WriteLine("Got {0}", exception.GetType());
                client.Abort();
            }
            catch (CommunicationException exception)
            {
                Console.WriteLine("Got {0}", exception.GetType());
                client.Abort();
            }
        }

       
    }
}
